import axios from 'axios'
import axiosConfig from '_config/axios-config'
import { defaultAxiosConfig } from './default-config'
import { request } from './request'
import { UploadFile } from './upload-file'
import { DownloadFile } from './download-file'
import { mockRequest } from './mock-request'
// 默认超时10s
axios.defaults.timeout = 10000
// 默认请求内容类型
axios.defaults.headers['Content-Type'] = 'application/json;charset=UTF-8'
axiosConfig.customAxiosConfig?.(axios)
// 加载方法默认配置
defaultAxiosConfig(axios)
// 加载自定义配置
// eslint-disable-next-line no-unused-expressions

export {
  request,
  UploadFile,
  DownloadFile,
  mockRequest
}
// 支持历史项目
export default request
